import { JSONSchemaRef, JSONSchema } from "../JSONSchemaTypes";
import { ASTNode } from "./parser";
export declare function isNumber(val: any): val is number;
export declare function isDefined(val: any): val is object;
export declare function isBoolean(val: any): val is boolean;
export declare function isString(val: any): val is string;
export declare function getNodeValue(node: ASTNode): any;
export declare function asSchema(schema: JSONSchemaRef | undefined): JSONSchema | undefined;
export declare function contains(node: ASTNode, offset: number, includeRightBound?: boolean): boolean;
export declare function equals(one: any, other: any): boolean;
export declare enum ErrorCode {
    Undefined = 0,
    EnumValueMismatch = 1,
    Deprecated = 2,
    UnexpectedEndOfComment = 257,
    UnexpectedEndOfString = 258,
    UnexpectedEndOfNumber = 259,
    InvalidUnicode = 260,
    InvalidEscapeCharacter = 261,
    InvalidCharacter = 262,
    PropertyExpected = 513,
    CommaExpected = 514,
    ColonExpected = 515,
    ValueExpected = 516,
    CommaOrCloseBacketExpected = 517,
    CommaOrCloseBraceExpected = 518,
    TrailingComma = 519,
    DuplicateKey = 520,
    CommentNotPermitted = 521,
    SchemaResolveError = 768
}
